<template>
    <el-collapse-item>
        <template #title>
            <h3
                class="rule-title"
                v-if="rule.type === 'remove_prefix' || rule.type === 'brand_model' || rule.type === 'params_by_value'"
            >
                {{ actionTypes[rule.type] }}
            </h3>
            <h3 class="rule-title" v-else>{{ rule.title }}</h3>
            <el-button plain @click.stop="$emit('onClone')">
                <font-awesome-icon icon="copy" />
            </el-button>
            <el-button plain @click.stop="$emit('onMoveUp')">
                <font-awesome-icon icon="caret-up" />
            </el-button>
            <el-button plain @click.stop="$emit('onMoveDown')">
                <font-awesome-icon icon="caret-down" />
            </el-button>
            <el-button type="danger" plain @click.stop="$emit('onDelete')" class="action_delete">
                <font-awesome-icon icon="trash" />
            </el-button>
        </template>
        <el-form label-position="top">
            <h3>Действие</h3>
            <el-select
                :model-value="rule.type"
                @update:modelValue="(newValue) => $emit('onUpdate', 'type', newValue)"
                style="min-width: 500px"
            >
                <el-option
                    v-for="(actionTitle, actionName) in actionTypes"
                    :key="actionName"
                    :label="actionTitle"
                    :value="actionName"
                >
                    {{ actionTitle }}
                </el-option>
            </el-select>
            <template
                v-if="rule.type !== 'remove_prefix' && rule.type !== 'brand_model' && rule.type !== 'params_by_value'"
            >
                <h3>Название правила</h3>
                <el-form-item>
                    <el-input
                        :model-value="rule.title"
                        @update:modelValue="(newValue) => $emit('onUpdate', 'title', newValue)"
                    />
                    <el-alert v-if="errors.name" type="error" show-icon :closable="false">
                        {{ errors.name }}
                    </el-alert>
                </el-form-item>
            </template>
            <h3>Выполнить если</h3>
            <template v-for="(eif, index) in rule.execute_if || []" :key="index">
                <RuleIf
                    :eif="eif"
                    @on-update="(path, value) => $emit('onUpdate', `execute_if.${index}.${path}`, value)"
                    @on-delete="removeIf(index)"
                />
            </template>
            <el-button plain @click="addIf">Добавить условие</el-button>
            <div
                v-if="
                    rule.type === 'regex' ||
                    rule.type === 'replace' ||
                    rule.type === 'remove_substr' ||
                    rule.type === 'set_value'
                "
            >
                <h3>Поле</h3>
                <el-row class="rule-row">
                    <el-select
                        :model-value="rule.field_type"
                        @update:modelValue="(newValue) => $emit('onUpdate', 'field_type', newValue)"
                    >
                        <el-option label="Данные магазина" value="price"> Данные магазина</el-option>
                        <el-option label="Результат" value="result"> Результат</el-option>
                    </el-select>
                    <el-input v-model="rule.field" />
                </el-row>
                <el-alert v-if="errors.field" type="error" show-icon :closable="false">
                    {{ errors.field }}
                </el-alert>
            </div>
            <div v-if="rule.type === 'regex'">
                <h3>Регулярное выражение</h3>
                <el-input class="monospace" type="textarea" v-model="rule.regex" autosize />
                <el-alert v-if="errors.regex" type="error" show-icon :closable="false">
                    {{ errors.regex }}
                </el-alert>
                <p>
                    Для распознавания значения переменных (напр. "test") используйте именованные группы —
                    (?'test'[0-9]+). Числовые суффиксы названий переменных игнорируются: "test2" будет распознано как
                    "test".
                </p>
                <el-switch
                    :model-value="rule.remove_found"
                    @update:modelValue="(newValue) => $emit('onUpdate', 'remove_found', newValue)"
                    size="large"
                    active-text="Удалить найденное вхождение из поля"
                    :inactive-value="0"
                    :active-value="1"
                />
                <h3>Примечание или ссылка на тест-кейсы</h3>
                <el-input v-model="rule.note" />
            </div>
            <div v-if="rule.type === 'replace'">
                <h3>Правила замены</h3>
                <el-input
                    class="monospace"
                    type="textarea"
                    autosize
                    v-model="rule.replaces"
                    @update:modelValue="(newValue) => $emit('onUpdate', 'replaces', newValue)"
                />
                <el-alert v-if="errors.replaces" type="error" show-icon :closable="false">
                    {{ errors.replaces }}
                </el-alert>
                <p>
                    Строки формата (оранж(евый)?|naranja)=>orange . Если регулярное выражение, идущее до стрелки,
                    выполняется, значение после стрелки подставляется в поле; и следующие строки не проверяются.
                </p>
            </div>
            <div v-if="rule.type === 'set_value'">
                <h3>Установить значение</h3>
                <el-input v-model="rule.replaces" />
                <el-alert v-if="errors.replaces" type="error" show-icon :closable="false">
                    {{ errors.replaces }}
                </el-alert>
                <p>Для добавления данных в массив используйте [] в названии поля.</p>
            </div>
            <div v-if="rule.type === 'params_by_value'">
                <h3></h3>
                <el-switch
                    :model-value="rule.remove_found"
                    @update:modelValue="(newValue) => $emit('onUpdate', 'remove_found', newValue)"
                    size="large"
                    active-text="Удалить найденные вхождение из поля"
                    :inactive-value="0"
                    :active-value="1"
                />
                <el-alert v-if="errors.remove_found" type="error" show-icon :closable="false">
                    {{ errors.remove_found }}
                </el-alert>
            </div>
            <div v-if="rule.type === 'remove_substr'">
                <h3>Список слов для удаления</h3>
                <el-input class="monospace" type="textarea" autosize v-model="rule.replaces" />
                <el-alert v-if="errors.replaces" type="error" show-icon :closable="false">
                    {{ errors.replaces }}
                </el-alert>
            </div>
        </el-form>
    </el-collapse-item>
</template>

<script>
import RuleIf from "@/views/pages/ParseRules/RuleIf.vue";

export default {
    components: { RuleIf },
    props: {
        rule: Object,
        errors: Object,
        fieldSources: Object,
        actionTypes: {
            type: Object,
            default() {
                return {
                    params_by_value: "Распознать параметры по значению",
                    regex: "Распознать параметры по рег.выражению ",
                    brand_model: "Распознать бренд и модель",
                    replace: "Заменить подстроку",
                    set_value: "Установить значение",
                    remove_prefix: "Убрать обозначение типа товара",
                    remove_substr: "Убрать слова",
                    skip: "Пропустить предложение",
                };
            },
        },
    },
    emits: ["onCreate", "onUpdate", "onDelete", "onMoveUp", "onMoveDown", "onClone"],
    methods: {
        addIf() {
            const newValue = this.rule.execute_if.concat([["price", "", "=", ""]]);
            this.$emit("onUpdate", "execute_if", newValue);
        },
        removeIf(index) {
            const newValue = this.rule.execute_if.filter((value, ind) => ind !== index);
            this.$emit("onUpdate", "execute_if", newValue);
        },
    },
};
</script>

<style scoped lang="scss">
.rule-title {
    margin: 20px 0 20px 0;
}

.el-collapse-item__header {
    h3 {
        flex-grow: 1;
    }

    & > .el-button.action_delete {
        margin-right: 20px;
    }
}

h2,
h3 {
    margin-top: 20px;
    margin-bottom: 10px;
}

.rule-row .el-select,
.rule-row .el-input {
    max-width: 200px;
    margin-right: 10px;
}

.monospace {
    font-family: monospace;
}

.el-radio-group {
    flex-wrap: nowrap;
}

.el-radio-button:deep(.el-radio-button__inner) {
    white-space: normal !important;
    line-height: 1.25;
}
</style>
